## garmin 196 functions
var last_time = 0.0;
var last_bearing = -1;

var init_variables = func{
	##pour test
	props.globals.getNode("/instrumentation/garmin196/panel-wpt-id").setValue("KSFO");
	props.globals.getNode("/instrumentation/garmin196/panel-wpt-range").setDoubleValue(28.3);
	props.globals.getNode("/instrumentation/garmin196/panel-wpt-ete").setValue("24:35");

	props.globals.getNode("/instrumentation/garmin196/antenne-deg",1).setDoubleValue(0);
	props.globals.getNode("/instrumentation/garmin196/max-speed",1).setDoubleValue(200);
	
	##status du gps
	#0 eteint
	#1 startup page
	#1x panel page
	props.globals.getNode("/instrumentation/garmin196/status",1).setDoubleValue(0);
	
	##popup windows
	#0 = pas de popup
	#1 = affichage du reglage de la lumiere
	props.globals.getNode("/instrumentation/garmin196/popup_status",1).setBoolValue(0);
	
	props.globals.getNode("/instrumentation/garmin196/serviceable",1).setBoolValue(0);
	props.globals.getNode("/instrumentation/garmin196/light",1).setDoubleValue(0);
	
	main_loop();
}
setlistener("/sim/signals/fdm-initialized",init_variables,0,0);

var main_loop = func{
	var time = getprop("/sim/time/elapsed-sec");
    var dt = time - last_time;
    last_time = time;
	
	settimer(main_loop, 0.3);
	calcul_turn_rate(dt);
	change_speed_display();
}

var nyi = func (x) { gui.popupTip(x ~ ": not yet implemented", 3); }

var power = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(x==0){
		if(serviceable==1){
			setprop("/instrumentation/garmin196/serviceable",0);
			setprop("/instrumentation/garmin196/status",0);
			setprop("/instrumentation/garmin196/popup_status",0);
			save_parameters();
		}else{
			setprop("/instrumentation/garmin196/serviceable",1);
			setprop("/instrumentation/garmin196/status",1);
			load_parameters();
		}
	}
	
	if(x==1 and serviceable==1){
		setprop("/instrumentation/garmin196/popup_status",1)
	}

}

var in = func (x){
	nyi("in");
}

var out = func (x){
	nyi("out");
}

var page = func (x){
	nyi("page");
}

var quit = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				setprop("/instrumentation/garmin196/popup_status",0);
				return;
			}
		}
	}
}

var enter = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				setprop("/instrumentation/garmin196/popup_status",0);
				return;
			}
			
			##validation de la startup page
			var status = getprop("/instrumentation/garmin196/status");
			if(status==1){
				setprop("/instrumentation/garmin196/status",10);
				return;
			}
		}
	}
}

var menu = func (x){
	nyi("menu");
}

var nrst = func (x){
	nyi("nrst");
}

var dto = func (x){
	nyi("dto");
}

var rockerup = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				var light_level = getprop("/instrumentation/garmin196/light");
				light_level = light_level + 0.1;
				if(light_level>1){
					light_level = 1;
				}
				setprop("/instrumentation/garmin196/light",light_level);
				return;
			}
		}
	}
}

var rockerdown = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				var light_level = getprop("/instrumentation/garmin196/light");
				light_level = light_level - 0.1;
				if(light_level<0){
					light_level = 0;
				}
				setprop("/instrumentation/garmin196/light",light_level);
				return;
			}
		}
	}
}

var rockerleft = func (x){
	nyi("rockerleft");
}

var rockerright = func (x){
	nyi("rockerright");
}

var load_parameters = func{
	fgcommand("loadxml", props.Node.new({ filename: getprop("/sim/fg-home")~"/aircraft-data/garmin196.xml", targetnode: "/instrumentation/garmin196/save" }));
	
	if(getprop("/instrumentation/garmin196/save/antenne-deg")!=nil){
		setprop("/instrumentation/garmin196/antenne-deg",getprop("/instrumentation/garmin196/save/antenne-deg"));
	}
	if(getprop("/instrumentation/garmin196/save/light")!=nil){
		setprop("/instrumentation/garmin196/light",getprop("/instrumentation/garmin196/save/light"));
	}
	if(getprop("/instrumentation/garmin196/save/max-speed")!=nil){
		setprop("/instrumentation/garmin196/max-speed",getprop("/instrumentation/garmin196/save/max-speed"));
	}
	
	
}

var save_parameters = func{
	##preparation
	props.globals.getNode("/instrumentation/garmin196/save/antenne-deg",1).setDoubleValue(getprop("/instrumentation/garmin196/antenne-deg"));
	props.globals.getNode("/instrumentation/garmin196/save/light",1).setDoubleValue(getprop("/instrumentation/garmin196/light"));
	props.globals.getNode("/instrumentation/garmin196/save/max-speed",1).setDoubleValue(getprop("/instrumentation/garmin196/max-speed"));
	
	fgcommand("savexml", props.Node.new({ filename: getprop("/sim/fg-home")~"/aircraft-data/garmin196.xml", sourcenode: "/instrumentation/garmin196/save" }));
}

##recalc speed to display
var change_speed_display = func{
	var max_speed = getprop("/instrumentation/garmin196/max-speed");
	var speed = getprop("/instrumentation/gps/indicated-ground-speed-kt");
	setprop("/instrumentation/garmin196/speed-display",315*speed/max_speed);
}

##calcul du turn rate
var calcul_turn_rate = func(dt){
	if(last_bearing==-1){
		last_bearing = getprop("/instrumentation/gps/magnetic-bug-error-deg");
	}
	bearing = getprop("/instrumentation/gps/magnetic-bug-error-deg");
	
	var turn_rate = abs(bearing - last_bearing);
	if(turn_rate>180){
		turn_rate = 360 - turn_rate;
 	}
	var sgn = 1;
	if(bearing - last_bearing<0){
		sgn = -1;
	}
	turn_rate = turn_rate/dt;
	if(turn_rate<10){##pour enlever les valeurs aberentes
		props.globals.getNode("/instrumentation/garmin196/turn-rate",1).setDoubleValue(sgn*turn_rate);
	}
	last_bearing = bearing;
}